﻿using Microsoft.AspNetCore.Mvc;
using System.IO;
using System.Net;
using System.Threading.Tasks;
using System;
//using System.Web.Http;

namespace JSViewerEmailReport.Controllers
{
    [Route("api/email")]
    public class EmailController : ControllerBase
    {
        [HttpPost("")]
        public async Task<IActionResult> SaveBlob()
        {
            // Check if the request contains a valid blob
            if (!MultipartRequestHelper.IsMultipartContentType(Request.ContentType))
            {
                return BadRequest("Invalid request content type");
            }

            // Get the file stream from the request
            var formCollection = await Request.ReadFormAsync();
            var file = formCollection.Files[0];

            // Read the file content into a MemoryStream
            using (var memoryStream = new MemoryStream())
            {
                await file.CopyToAsync(memoryStream);

                SendEmail(memoryStream);

                SaveToFile(memoryStream); // Optional
                return Ok("Blob saved successfully");
            }
        }

        private void SendEmail(MemoryStream memoryStream)
        {
            // Here, implement the code to send email!
            //https://stackoverflow.com/questions/5336239/attach-a-file-from-memorystream-to-a-mailmessage-in-c-sharp
            throw new NotImplementedException();
        }

        private static void SaveToFile(MemoryStream memoryStream)
        {
            using (var fileStream = new FileStream("C:\\sample.pdf", FileMode.CreateNew))
            {
                memoryStream.WriteTo(fileStream);
                fileStream.Close();
                memoryStream.Close();
            }
        }
    }

    // Helper class to check multipart content type
    public static class MultipartRequestHelper
    {
        public static bool IsMultipartContentType(string contentType)
        {
            return !string.IsNullOrEmpty(contentType) &&
                   contentType.IndexOf("multipart/", StringComparison.OrdinalIgnoreCase) >= 0;
        }
    }
}
